/* This file can be redistributed and used under GNU Library General Public
 * License. (c) 2000 Micha Moskal <malekith@topnet.pl>. 
 * $Id: primitives.cc,v 1.6 2000/09/09 17:59:14 malekith Exp $ */

#define _V_PRIVATE
#include <v/v.h>
#include <v/term.h>

#include <ctype.h>

void Rect::draw_frame_at(int X, int Y, int c, bool fill)
{
	go(X,Y++);
	print(get_frame(-1,-1),c);
	int k = w - 2;
	while (k-->0) print(get_frame(2,0), c);
	print(get_frame(1,-1),c);
	k = h - 2;
	while (k-- > 0) {
		go(X,Y);
		print(get_frame(3,0),c);
		if (fill) {
			int z = w - 2;
			while (z-->0) print(' ', c);
		} else 
			go(X + w - 1, Y);
		print(get_frame(3,0),c);
		Y++;
	}

	go(X,Y);
	print(get_frame(-1,1),c);
	k = w - 2;
	while (k-->0) print(get_frame(2,0), c);
	print(get_frame(1,1),c);
	
}

void v_alt_print(const String &s, int cn, int ca, int len)
{
	bool alt = 0;
	const char *p = s;
	
	while (len--) {
		if (*p == '~') { 
			p++; 
			if (*p != '~')
				alt = !alt; 
		}
		if (*p)
			print((unsigned char)*p++, alt ? ca : cn);
		else if (len < 0) 
			break;
		else
			print(' ', alt ? ca : cn);
	}
}

int v_alt_strlen(const String &s)
{
	int r = 0;
	const char *p = s;
	
	while (*p) {
		if (*p++ == '~') {
			if (*p) p++;
			else break;
		}
		r++;
	}
	return r;
}

bool _v_alt_checkkey(const String & s, int k)
{
	int x;
	
	if (strchr(s, '~'))
		x = tolower(*(strchr(s, '~') + 1));
	else
		return false;
		
	if (k >= 'A' && k <= 'Z')
		k = tolower(k);
	//k &= !key_meta;
	
	return k == x;
}
